﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace WindowsFormsApplication374
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Override.SummaryDisplayArea = Infragistics.Win.UltraWinGrid.SummaryDisplayAreas.BottomFixed;
            SummarySettings ss = this.ultraGrid1.DisplayLayout.Bands[0].Summaries.Add(SummaryType.Sum, this.ultraGrid1.DisplayLayout.Bands[0].Columns["Total"]);
            ss.SummaryType = SummaryType.Custom;
            ss.CustomSummaryCalculator = new SummaryCalculator();
        }        

        public class SummaryCalculator : ICustomSummaryCalculator
        {
            private double total = 0;

            public void AggregateCustomSummary(SummarySettings settings, UltraGridRow row)
            {
                foreach (UltraGridRow chRow in row.ChildBands[0].Rows)
                {
                    string cellValue = chRow.Cells[settings.SourceColumn].Text;
                    double val = 0;
                    if (double.TryParse(cellValue, out val))
                        this.total += val;
                }
            }

            public void BeginCustomSummary(SummarySettings settings, RowsCollection rows)
            {
                this.total = 0;
            }

            public object EndCustomSummary(SummarySettings settings, RowsCollection rows)
            {
                return this.total;
            }

        }
    }
}
